## cwltool 3.1.20250925164626

=== Makefile ===
# This file is part of cwltool,
# https://github.com/common-workflow-language/cwltool/, and is
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Contact: common-workflow-language@googlegroups.com

# make format to fix most python formatting errors
# make pylint to check Python code for enhanced compliance including naming
#  and documentation
# make coverage-report to check coverage of the python scripts by the tests

MODULE=cwltool

# `SHELL=bash` doesn't work for some, so don't use BASH-isms like
# `[[` conditional expressions.
PYSOURCES=$(wildcard ${MODULE}/**.py cwltool/cwlprov/*.py tests/*.py tests/cwl-conformance/*.py) setup.py
DEVPKGS=diff_cover pylint pep257 pydocstyle 'tox<4' tox-pyenv auto-walrus \
	isort wheel autoflake pyupgrade bandit -rlint-requirements.txt\
	-rtest-requirements.txt -rmypy-requirements.txt -rdocs/requirements.txt
DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
	   python-flake8 python-mock shellcheck

VERSION=3.1.$(shell TZ=UTC git log --first-parent --max-count=1 \
	--format=format:%cd --date=format-local:%Y%m%d%H%M%S)
mkfile_dir := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
UNAME_S=$(shell uname -s)

## all                    : default task (install cwltool in dev mode)
all: dev

## help                   : print this help message and exit
help: Makefile
	@sed -n 's/^##//p' $<

## cleanup                : shortcut for "make sort_imports format flake8 diff_pydocstyle_report"
cleanup: sort_imports format flake8 diff_pydocstyle_report

## install-dep            : install most of the development dependencies via pip
install-dep: install-dependencies

install-dependencies: FORCE
	pip install --upgrade $(DEVPKGS)
	pip install -r requirements.txt

install-doc-dep:
	pip install -r docs/requirements.txt

## install-deb-dep        : install many of the dev dependencies via apt-get
install-deb-dep:
	sudo apt-get install $(DEBDEVPKGS)

## install                : install the cwltool module with the "deps" dependency (galaxy-tool-util)
install: FORCE
	pip install .[deps]

## dev                    : install the cwltool module in dev mode
dev: install-dep
	pip install -e .[deps]


## dist                   : create a module package for distribution
dist: dist/${MODULE}-$(VERSION).tar.gz

dist/${MODULE}-$(VERSION).tar.gz: $(SOURCES)
	python3 -m build

## docs                   : make the docs
docs: FORCE
	cd docs && $(MAKE) html

## clean                  : clean up all temporary / machine-generated files
clean: FORCE
	rm -f ${MODULE}/*.pyc tests/*.pyc *.so ${MODULE}/*.so cwltool/cwlprov/*.so
	rm -Rf ${MODULE}/__pycache__/
	rm -Rf build
	rm -Rf .coverage
	rm -f diff-cover.html

# Linting and code style related targets
## sort_import            : sorting imports using isort: https://github.com/timothycrosley/isort
sort_imports: $(PYSOURCES) mypy-stubs
	isort $^

remove_unused_imports: $(PYSOURCES)
	autoflake --in-place --remove-all-unused-imports $^

pep257: pydocstyle
## pydocstyle             : check Python docstring style
pydocstyle: $(PYSOURCES)
	pydocstyle --add-ignore=D100,D101,D102,D103 $^ || true

pydocstyle_report.txt: $(PYSOURCES)
	pydocstyle setup.py $^ > $@ 2>&1 || true

## diff_pydocstyle_report : check Python docstring style for changed files only
diff_pydocstyle_report: pydocstyle_report.txt
	diff-quality --compare-branch=main --violations=pydocstyle --fail-under=100 $^

## codespell-check        : check for common misspellings
codespell-check:
	@codespell $(shell git ls-files | grep -v cwltool/schemas | grep -v cwltool/jshint/ | grep -v mypy-stubs) \
		|| (echo Probable typo foun. Run \"make codespell-fix\" to accept suggested fixes, or add the word to the ignore list in setup.cfg ; exit 1)

## codespell-fix          : fix common misspellings
codespell-fix:
	@codespell -w $(shell git ls-files | grep -v cwltool/schemas | grep -v cwltool/jshint/ | grep -v mypy-stubs)

## format                 : check/fix all code indentation and formatting (runs black)
format:
	black --exclude cwltool/schemas --exclude cwltool/_version.py setup.py cwltool.py cwltool tests mypy-stubs

format-check:
	black --diff --check --exclude cwltool/schemas setup.py --exclude cwltool/_version.py cwltool.py cwltool tests mypy-stubs

## pylint                 : run static code analysis on Python code
pylint: $(PYSOURCES)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
                $^ -j0|| true

pylint_report.txt: $(PYSOURCES)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
		$^ -j0> $@ || true

diff_pylint_report: pylint_report.txt
	diff-quality --compare-branch=main --violations=pylint pylint_report.txt

.coverage: testcov

coverage: .coverage
	coverage report

coverage.xml: .coverage
	coverage xml

coverage.html: htmlcov/index.html

htmlcov/index.html: .coverage
	coverage html
	@echo Test coverage of the Python code is now in htmlcov/index.html

coverage-report: .coverage
	coverage report

diff-cover: coverage.xml
	diff-cover --compare-branch=main $^

diff-cover.html: coverage.xml
	diff-cover --compare-branch=main $^ --html-report $@

## test                   : run the cwltool test suite
test: $(PYSOURCES)
	python3 -m pytest ${PYTEST_EXTRA}

## testcov                : run the cwltool test suite and collect coverage
testcov: $(PYSOURCES)
	python3 -m pytest --cov --cov-config=.coveragerc --cov-report= ${PYTEST_EXTRA}

sloccount.sc: $(PYSOURCES) Makefile
	sloccount --duplicates --wide --details $^ > $@

## sloccount              : count lines of code
sloccount: $(PYSOURCES) Makefile
	sloccount $^

list-author-emails:
	@echo 'name, E-Mail Address'
	@git log --format='%aN,%aE' | sort -u | grep -v 'root'

mypy3: mypy
mypy: $(PYSOURCES)
	MYPYPATH=$$MYPYPATH:mypy-stubs mypy $^

mypyc: $(PYSOURCES)
	MYPYPATH=mypy-stubs CWLTOOL_USE_MYPYC=1 pip install --verbose -e . \
		 && pytest -vv ${PYTEST_EXTRA}

shellcheck: FORCE
	shellcheck build-cwltool-docker.sh cwl-docker.sh release-test.sh conformance-test.sh \
		cwltool-in-docker.sh

pyupgrade: $(PYSOURCES)
	pyupgrade --exit-zero-even-if-changed --py39-plus $^
	auto-walrus $^

release-test: FORCE
	git diff-index --quiet HEAD -- || ( echo You have uncommitted changes, please commit them and try again; false )
	./release-test.sh

release:
	export SETUPTOOLS_SCM_PRETEND_VERSION_FOR_CWLTOOL=${VERSION} && \
	./release-test.sh && \
	. testenv2/bin/activate && \
		pip install build && \
		python3 -m build testenv2/src/${MODULE} && \
		pip install twine && \
		twine upload testenv2/src/${MODULE}/dist/* && \
		git tag ${VERSION} && git push --tags

flake8: $(PYSOURCES)
	flake8 $^

FORCE:

# Use this to print the value of a Makefile variable
# Example `make print-VERSION`
# From https://www.cmcrossroads.com/article/printing-value-makefile-variable
print-%  : ; @echo $* = $($*)

=== requirements.txt ===
requests>=2.6.1
ruamel.yaml>=0.16.0,<0.19
rdflib>=4.2.2,<7.3
schema-salad>=8.9,<9
prov==1.5.1
mypy-extensions
psutil>=5.6.6
coloredlogs
pydot>=1.4.1
argcomplete>=1.12.0
pyparsing!=3.0.2  # breaks --print-dot (pydot) https://github.com/pyparsing/pyparsing/issues/319
cwl-utils>=0.32
spython>=0.3.0
rich-argparse

=== debian/changelog ===
cwltool (3.1.20250925164626-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * Refreshed patches
  * Added patch to support the older pydot version in Debian (2.x).

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 30 Sep 2025 15:31:57 +0200

cwltool (3.1.20250110105449-3) unstable; urgency=medium

  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of "auto" for setting
    the amount of parallel testing.
  * d/rules: clean up extra license files.
  * d/cwltool.lintian-overrides: update syntax
  * New patch to better mark the included CWL files as executable.
  * New patch to improve user privacy by removing externally hosted
    badge images from the README.
  * Simplify test invocation and switch to autopkgtest-pkg-pybuild

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 30 Jan 2025 13:22:50 +0100

=== debian/control ===
Source: cwltool
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: science
Testsuite: autopkgtest-pkg-pybuild
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-sphinxdoc <!nodoc>,
               procps <!nocheck>,
               python3,
               python3-all,
               pybuild-plugin-pyproject,
               python3-setuptools,
               python3-setuptools-scm,
               python3-sphinx <!nodoc>,
               python3-sphinx-autoapi <!nodoc>,
               python3-sphinx-autodoc-typehints <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               python3-sphinxcontrib.autoprogram <!nodoc>,
               python3-doc <!nodoc>,
               python-rdflib-doc <!nodoc>,
               python3-coloredlogs <!nocheck> <!nodoc>,
               python3-rdflib <!nocheck>,
               python3-schema-salad (>=8.4.20230808163024) <!nocheck> <!nodoc>,
               python3-html5lib <!nocheck>,
               python3-sparqlwrapper <!nocheck>,
               python3-keepalive <!nocheck>,
               python3-ruamel.yaml <!nocheck>,
               python3-pytest <!nocheck>,
               python3-pytest-httpserver <!nocheck>,
               python3-pytest-xdist <!nocheck>,
               python3-pytest-runner <!nocheck>,
               python3-pytest-mock <!nocheck>,
               python3-cwl-utils (>= 0.32) <!nocheck> <!nodoc>,
               python3-mypy-extensions <!nocheck> <!nodoc>,
               python3-psutil <!nocheck> <!nodoc>,
               python3-prov <!nocheck> <!nodoc>,
               python3-arcp <!nocheck>,
               python3-pydot <!nocheck> <!nodoc>,
               python3-argcomplete <!nocheck> <!nodoc>,
               python3-spython <!nocheck> <!nodoc>,
               python3-rich-argparse <!nocheck> <!nodoc>,
               nodejs <!nocheck>,
               jq <!nocheck>,
               help2man
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/cwltool
Vcs-Git: https://salsa.debian.org/med-team/cwltool.git
Homepage: https://cwltool.readthedocs.io/
Rules-Requires-Root: no

Package: cwltool
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         python3-mypy-extensions,
         python3-arcp,
         python3-argcomplete,
         python3-cwl-utils
Recommends: nodejs
Suggests: podman | docker.io | singularity-container,
          cwltool-doc
Breaks: toil (<< 5.12.0)
Provides: cwl-runner
Description: Common Workflow Language reference implementation
 This is the reference implementation of the Common Workflow Language
 standards.
 .
 The CWL open standards are for describing analysis workflows and tools in a
 way that makes them portable and scalable across a variety of software and
 hardware environments, from workstations to cluster, cloud, and high
 performance computing (HPC) environments. CWL is designed to meet the needs of
 data-intensive science, such as Bioinformatics, Medical Imaging, Astronomy,
 Physics, and Chemistry.
 .
 The CWL reference implementation (cwltool) is intended to be feature complete
 and to provide comprehensive validation of CWL files as well as provide other
 tools related to working with CWL descriptions.

Package: cwltool-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: Common Workflow Language reference implementation -- docs
 This is the docs for the reference implementation of the Common Workflow
 Language standards.
 .
 The CWL open standards are for describing analysis workflows and tools in a
 way that makes them portable and scalable across a variety of software and
 hardware environments, from workstations to cluster, cloud, and high
 performance computing (HPC) environments. CWL is designed to meet the needs of
 data-intensive science, such as Bioinformatics, Medical Imaging, Astronomy,
 Physics, and Chemistry.
 .
 The CWL reference implementation (cwltool) is intended to be feature complete
 and to provide comprehensive validation of CWL files as well as provide other
 tools related to working with CWL descriptions.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
include /usr/share/dpkg/default.mk
export PYBUILD_DESTDIR=$(CURDIR)/debian/cwltool
export PYBUILD_AFTER_TEST=rm -Rf {build_dir}/tmp/ {build_dir}/main.cwl {build_dir}/output.txt*
export PYBUILD_TEST_ARGS=-k 'not (test_http_path_mapping or test_get_subgraph or test_udocker_usage_should_not_write_cid_file or test_udocker_should_display_memory_usage or test_content_types or test_get_step or test_udocker_nobanner)' $(DEB_BUILD_OPTION_PARALLEL:%=-n %) --ignore cwltool/schemas/ -rs --pyargs cwltool
# test_http_path_mapping requires internet access (could be mocked?)
# test_get_{subgraph,step} embedded local path isn't being cleaned properlyexport HOME=$(shell echo $$PWD"/fakehome")

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_build:
	PYTHONPATH=$(CURDIR)/cwltool $(MAKE) docs

debian/cwltool.1: debian/rules debian/cwltool.help2man
	export HOME=$(shell echo $$PWD"/fakehome") ; python3 setup.py develop --user ; \
	help2man --version-string $(DEB_VERSION_EPOCH_UPSTREAM) -I debian/cwltool.help2man -N \
		-o debian/cwltool.1  'python3 -m cwltool'
	sed -i 's/__main__.py/cwltool/g' debian/cwltool.1

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_installman: debian/cwltool.1
	dh_installman
else
override_dh_installman:
endif

execute_after_dh_auto_install:
	find debian -name '*.json' -exec chmod a-x {} \;
	find debian -name LICENSE.txt -delete

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/,dversionmangle=auto \
https://pypi.debian.net/cwltool/cwltool-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## cwltool 3.1.20251031082601

=== requirements.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 requests>=2.6.1
 ruamel.yaml>=0.16.0,<0.19
-rdflib>=4.2.2,<7.3
+rdflib>=4.2.2,<7.5
 schema-salad>=8.9,<9
 prov==1.5.1
 mypy-extensions

=== debian/changelog ===
cwltool (3.1.20251031082601-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Removed patch applied upstream.
  * Fully drop dependency on python3-prov.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 07 Jan 2026 12:57:55 +0100

## cwltool 3.1.20260108082145

=== Makefile ===
--- 
+++ 
@@ -190,7 +190,7 @@
 		cwltool-in-docker.sh
 
 pyupgrade: $(PYSOURCES)
-	pyupgrade --exit-zero-even-if-changed --py39-plus $^
+	pyupgrade --exit-zero-even-if-changed --py310-plus $^
 	auto-walrus $^
 
 release-test: FORCE

=== requirements.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 requests>=2.6.1
-ruamel.yaml>=0.16.0,<0.19
-rdflib>=4.2.2,<7.5
+ruamel.yaml>=0.16.0,<0.20
+rdflib>=4.2.2,<7.6
 schema-salad>=8.9,<9
 prov==1.5.1
 mypy-extensions
@@ -12,3 +12,4 @@
 cwl-utils>=0.32
 spython>=0.3.0
 rich-argparse
+typing-extensions>=4.1.0

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@NO_COLOR=1 $(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
cwltool (3.1.20260108082145-1) unstable; urgency=medium

  * New upstream version
  * Refreshed patches.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 24 Jan 2026 20:02:02 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
                python-rdflib-doc <!nodoc>,
                python3-coloredlogs <!nocheck> <!nodoc>,
                python3-rdflib <!nocheck>,
-               python3-schema-salad (>=8.4.20230808163024) <!nocheck> <!nodoc>,
+               python3-schema-salad (>=8.9) <!nocheck> <!nodoc>,
                python3-html5lib <!nocheck>,
                python3-sparqlwrapper <!nocheck>,
                python3-keepalive <!nocheck>,
@@ -35,7 +35,6 @@
                python3-cwl-utils (>= 0.32) <!nocheck> <!nodoc>,
                python3-mypy-extensions <!nocheck> <!nodoc>,
                python3-psutil <!nocheck> <!nodoc>,
-               python3-prov <!nocheck> <!nodoc>,
                python3-arcp <!nocheck>,
                python3-pydot <!nocheck> <!nodoc>,
                python3-argcomplete <!nocheck> <!nodoc>,
@@ -44,7 +43,7 @@
                nodejs <!nocheck>,
                jq <!nocheck>,
                help2man
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/cwltool
 Vcs-Git: https://salsa.debian.org/med-team/cwltool.git
 Homepage: https://cwltool.readthedocs.io/
